/* 
 * HISTORY
 * $Log: if_wl.c,v $
 * Revision 1.12  1998/12/05 19:24:30  stuart
 * encryption support sent in by Steve Bellovin <smb@research.att.com>
 *
 * Revision 1.11  1998/05/03 04:05:56  stuart
 * *** empty log message ***
 *
 * Revision 1.10  1997/08/20 15:07:24  stuart
 * made the structure members of 'struct wl_softc' consistent; used flags for
 * booleans instead of separate structure members
 * added an ioctl to get the flags out
 * cleaned up some card initialization problems, and fixed the bug where
 * loading the multicast address list didn't work; don't need ALLMULTI for
 * roaming anymore
 *
 * Revision 1.9  1997/08/16 15:58:40  stuart
 * changes for 3.0, changes for 2.4GHz cards
 *
 * Revision 1.8  1997/04/07 15:18:57  stuart
 * BSD/OS 3.0 changes, move some printfs to ccdprintfs, hack for roaming
 * with version 2.xx cards that don't seem to ever set their config bit.
 *
 * Revision 1.7  1996/11/15 04:25:47  stuart
 * use cs_spec_lookup to get card strings if USE_CS_SPEC_LOOKUP is defined
 *
 * Revision 1.6  1996/10/24 18:03:40  stuart
 * add support for version 2 cards (new card identification string)
 *
 * Revision 1.5  1996/06/20 13:23:44  stuart
 * changed the beacon logic to make ioctl consistent with the way that
 * beacons are added in the interrupt routine
 *
 * Revision 1.4  1996/04/21 05:05:56  stuart
 * interim checkin
 *
 * Revision 1.3  1996/04/20 16:50:26  stuart
 * interim checkin
 *
 * Revision 1.1  1996/04/14 05:03:57  stuart
 * Initial revision
 *
 * Revision 1.2  1996/03/03 09:25:01  vixie
 * check in stuff from sklower, was if_wlp.c
 *
 * Revision 1.18  1996/01/31  05:45:41  gnguyen
 * Hooks to trace packet
 *
 * Revision 1.17  1996/01/20  21:48:14  gnguyen
 * Change tracing hooks
 *
 * Revision 1.16  1996/01/11  21:36:22  gnguyen
 * Rearrage code in wlpread to read signal strength before BPF
 *
 * Revision 1.15  1995/11/30  00:27:22  stemm
 * Added hooks to measure initialization time.
 *
 * Revision 1.14  1995/10/22  02:16:18  padmanab
 * Changed wlpprobe() so that it only succeeds for the 915 MHz
 * WaveLAN (Version 1.00). Allows operation in either slot and
 * simultaneously with the 2.4 GHz WaveLAN.
 *
 * Revision 1.13  1995/10/19  19:28:36  padmanab
 * NO CHANGES MADE. Checked in because of uid problem on giza.
 *
 * Revision 1.12  1995/10/19  03:30:58  padmanab
 * Made changes for the 2.4 GHz WaveLAN. Detects the type of WaveLAN
 * and does appropriate things, so this works with both types of
 * WaveLANs. Works for both slots separately but not simultaneously.
 *
 * Revision 1.12  1995/10/19  03:30:58  padmanab
 * Made changes for the 2.4 GHz WaveLAN. Detects the type of WaveLAN
 * and does appropriate things, so this works with both types of
 * WaveLANs. Works for both slots separately but not simultaneously.
 *
 * Revision 1.11  1995/08/09  01:11:42  hari
 * Print out comp number
 *
 * Revision 1.10  1995/07/26  11:22:17  ss
 * added some of the support for 2.4Ghz card
 *
 * Revision 1.9  1995/06/04  00:36:28  elan
 * Fix RCS mixup: merge into SNR fix, TOS additions.
 *
 * Revision 1.4  1995/06/04  00:17:55  hari
 * Added TOS support
 *
 * Revision 1.3  1995/04/26  17:18:22  hari
 * Wrapped DEBUG around overrun messages
 *
 * Revision 1.2  1995/04/25  02:43:42  ss
 * bug in snr array code
 *
 * Revision 1.1  1995/03/30  22:03:34  ss
 * Initial revision
 *
 * Revision 1.7  1995/03/07  23:29:57  hari
 * Added wlp ioctl for beacons
 *
 * Revision 1.6  1995/03/06  22:33:53  ss
 * fixed ifp->if_flags = IFF_MULTICAST | IFF_ALLMULTI to |=
 *
 * Revision 1.5  1995/03/06  22:03:37  hari
 * fixed overrun problems
 *
 * Revision 1.4  1995/02/09  12:28:43  elan
 * started modifications for bpf compatibility.  Quick checkin for srini.
 *
 * Revision 1.3  1995/02/07  16:18:52  ss
 * fixed stuff relating to bpf and wavelan
 *
 * Revision 1.2  1995/02/02  14:40:51  elan
 * Fixed Multicast support code.
 *
 * Revision 1.1  1995/02/02  12:07:11  elan
 * Initial revision
 *
 * Revision 1.2  1994/12/13  21:48:31  elan
 * *** empty log message ***
 *
 * Revision 1.1  1994/12/09  02:56:43  elan
 * Initial revision
 *
 * Revision 1.1  1994/06/02  20:21:27  klemets
 * Initial revision
 *
 * Ported to BSDI by Robert Morris.
 * Ported to WILDBOAR by Paul Vixie and Stephen Stuart.
 *                       <paul@vix.com> <stuart@vix.com>
 */
/*
 * NCR WaveLAN PCMCIA driver.
 *
 * Copyright 1994, Anders Klemets <klemets@it.kth.se>
 *
 * This software may be freely distributed for noncommercial purposes
 * as long as this notice is retained.
 */
#include <sys/param.h>
#include <sys/systm.h>
#include <sys/mbuf.h>
#include <sys/buf.h>
#include <sys/protosw.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/errno.h>
#include <sys/syslog.h>
#include <sys/device.h>

#include <vm/vm.h>

#include <net/if.h>
#include <net/if_types.h>
#include <net/if_dl.h>
#include <net/netisr.h>
#include <net/route.h>

#ifdef INET
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/if_ether.h>
#endif

#ifdef NS
#include <netns/ns.h>
#include <netns/ns_if.h>
#endif

#include <i386/isa/isa.h>
#include <i386/isa/isavar.h>
#include <i386/isa/icu.h>
/* from i386/isa/isa.c: */
void dyna_intr_establish(int intr, struct intrhand *ih, enum devclass devtype);

#include <machine/cpu.h>

#include <i386/eisa/eisa.h>
#include <i386/pci/pci.h>

#include <net/bpf.h>
#include <net/bpfdesc.h>

#include "if_wlreg.h"

#ifdef WL_CC_DEBUG
   int wl_cc_debug = 1;
#  define ccdprintf(x)	{ if (wl_cc_debug) printf x ; }
#else
#  define ccdprintf(x)
#endif

#include <i386/pcmcia/pccs_meta.h>
#include <i386/pcmcia/cs_handle.h>
#include <i386/pcmcia/cs_irq.h>
#include <i386/pcmcia/cs_cisutil.h>
#include <i386/pcmcia/cs_errno.h>
#include <i386/pcmcia/cs_memrw.h>
#include <i386/pcmcia/cs_tplsvc.h>
#include <i386/pcmcia/cs_event.h>
#include <i386/pcmcia/cs_iop.h>
#include <i386/pcmcia/cs_win.h>
#include <i386/pcmcia/cs_rio.h>
#include <i386/pcmcia/cs_cli.h>
#include <i386/pcmcia/cs_conf.h>
#include <i386/pcmcia/cs_pm.h>
#include <i386/pcmcia/cs_spec.h>

/* from i386/pcmcia/cs_cisutil.c: */
int cu_parse_conf(u_char *buf, int len, struct tpcc *tpcc);
/* from i386/pcmcia/cs_util.c: */
int cu_configured(CliHandle_t *CliHandle, int socket);

#include <bpfilter.h>

#define WL_NPORT	16	/* 16 8-bit registers */
#define SPLNET		splimp	/* NOT splnet */
#define loutb		outsb
#define linb		insb

static int	xmt_watch = 0;

static u_char	beaconindaddr[ETHER_ADDR_LEN]
		= {0x09, 0x00, 0x0e, 0x20, 0x03, 0x00};

typedef struct wl_softc {
	struct device	wl_dev;		/* base device */
	struct isadev	wl_id;		/* ISA device */
	struct intrhand	wl_ih;		/* interrupt vectoring */
	struct arpcom   wl_ac;		/* Common ethernet part. */
#define	wl_if		wl_ac.ac_if	/* network visible interface */
#define	wl_enaddr	wl_ac.ac_enaddr	/* hardware address */
	u_char		wl_nwid[2];	/* WaveLAN network ID */
	int		wl_stop;	/* Current 82593 Stop Hit Register */
	int		wl_flags;	/* Flags, and their values */
#define WL_RUNNING              0x0001
#define WL_SEATED               0x0002
#define WL_TBUSY                0x0004
#define WL_MMI_INITED           0x0008
#define WL_CMD_WAIT             0x0010
#define WL_CMD_REQUEST          0x0020
#define WL_DEFERRED             0x0040
#define WL_POWER_DOWN           0x0080
#define WL_INIT_DEFERRED        0x0100
#define WL_ALLNWID_MODE         0x0200
#define WL_ATTACHED             0x0400
#define WL_OVERRUNNING          0x0800
#define WL_GATHER_SNR           0x1000
#define WL_ALLMULTI             0x2000
#define WL_V2CARD               0x4000
#define WL_NOMODEM		0x8000
#ifdef TIMER
	int     	wl_timer;
#endif TIMER
	short		wl_mode;
	int		wl_rfp;		/* last DMA machine receive pointer */
	u_char		wl_status;
	struct i82593	wl_cfblk;
	struct wl_cntrs	wl_cntrs;

	int		wl_ispccard;
	int		wl_socket;
	int		wl_cfstat;
	int		wl_irq;
	int		wl_base;
	CliHandle_t	wl_clihdl;
	cs_rio_t	wl_rio;
	cs_rirq_t	wl_rirq;
	cs_cfg_t	wl_rcfg;
	struct tpcc	wl_tpcc;
#define	WL_MAXFREQS		30
	unsigned	wl_freq;
	unsigned	wl_freqlist[WL_MAXFREQS];
	unsigned short	wl_doencrypt;
	unsigned char	wl_key[8];
} wl_softc_t;

#define ESAME(E,F) (E[0]==F[0] \
               && E[1]==F[1] \
               && E[2]==F[2] \
               && E[3]==F[3] \
               && E[4]==F[4] \
               && E[5]==F[5])

#define EZERO(E) (E[0]==0 \
               && E[1]==0 \
               && E[2]==0 \
               && E[3]==0 \
               && E[4]==0 \
               && E[5]==0)

#define READ_PSA(addr) read_psa(sc, addr)

static char
read_psa(struct wl_softc *sc, int addr) {
	static const int is_attr = 1;
	char ret;

	if (cs_pm_read(sc->wl_socket, is_attr,
		       PSA_ADDR + 2 * addr, &ret,
		       sizeof(char)))
	{
		printf("wl: read_psa(sock %d, addr %d): cs_pm_read failed\n",
		       sc->wl_socket, addr);
		ret = 0xff;
	}
	return (ret);
}

#define WLPSOFTC(unit)	((struct wl_softc *) wlcd.cd_devs[unit])
#define WLPIF(unit)	(WLPSOFTC(unit)->wl_ac.ac_if)

int wl_probe(struct device *, struct cfdata *, void *);
static void wl_attach(struct device *, struct device *, void *);
int wl_intr(struct wl_softc *);
static int wl_init(int unit);
int wl_start(struct ifnet *);
int wl_ioctl(struct ifnet *ifp, u_long cmd, caddr_t data);

int wl_reset(int unit);
int wl_watch(caddr_t b_ptr);
int wl_rcv(int unit);
void wl_xmt(int unit, struct mbuf *m);
int wl_diag(int unit);
int wl_config(int unit);
int wl_cmd(int unit, char *str, int cmd, int result);
u_short wl_mmiread(int base, u_short reg);
static int wl_start_of_frame(int unit, int rfp);
static wl_graceful_shutdown(int unit);
static void wl_getsnr(int unit, struct ether_header *ehp, u_char siglvl,
		 u_char sillvl, u_char sigqual);
void wl_dump(int unit);
int read_ringbuf(int unit, int addr, char *buf, int len);
void wl_notify(struct device *dev);
int wl_cc_attach(struct wl_softc *sc, int sock);
int wl_cc_detach(struct wl_softc *sc, int sock);
int wl_cc_probe(struct wl_softc *sc, int sock);

static void wl_eep_wait(wl_softc_t * const sc, unsigned us_per_tick, int ticks);
static void wl_eep_read(wl_softc_t * const sc, unsigned reg, u_int16_t *datap, unsigned int amount);
static void wl_read_frequency_list(wl_softc_t * const sc);
static void wl_info_print(wl_softc_t * const sc);
static void wl_modem_init(wl_softc_t * const sc);

struct cfdriver wlcd = {
	NULL, "wl", wl_probe, wl_attach, DV_IFNET, sizeof(struct wl_softc)
};

#if !defined(USE_CS_SPEC_LOOKUP)
struct ccstr {
	char	*vstr;
	int	vlen;
} wl_ccstr[] = {
	{ "\004\001NCR\0WaveLAN/PCMCIA\0Version 1.00", 33 },
	{ "\004\001NCR\0WaveLAN/PCMCIA\0Version 1.01", 33 },
	{ "\005\0Digital\0RoamAbout/DS\0Version 2.00", 35 }
} ;
#define NWLCCSTR (sizeof wl_ccstr / sizeof wl_ccstr[0])
#endif

/*
 *	Slot 1: flags=0x1<UP,UNKNOWN_CARD>
 *		Manufacturer Name: "NCR"
 *		Product Name: "WaveLAN/PCMCIA"
 *		Additional Info1: "Version 1.00"
 *		Function ID: None
 *		Assigned IRQ: None
 *		Assigned I/O port1: None
 */

static void
wl_eep_wait(wl_softc_t * const sc, unsigned us_per_tick, int ticks)
{
	while (ticks-- > 0 && (wl_mmiread(sc->wl_base, MMC_EE_STATUS) & EE_STATUS_BUSY))
		DELAY(us_per_tick);
	if (ticks < 0)
		printf("%s: wl_eep_wait: timed out\n", sc->wl_if.if_name);
}

static void
wl_eep_read(wl_softc_t * const sc, unsigned reg,
	   u_int16_t *datap, unsigned int amount)
{
	datap += amount;		/* Position at the end of the area */

	/* Write the address */
	MMI_WRITE(MMC_EE_ADDR, reg + amount - 1);
 
	/* Loop on all buffer */  
	while (amount-- > 0) {
		/* Write the read command */
		MMI_WRITE(MMC_EE_CTRL, EE_CTRL_READ);

		/* Wait until EEprom is ready (should be quick !) */
		wl_eep_wait(sc, 10, 100);

		/* Read the value */
		*--datap = (wl_mmiread(sc->wl_base, MMC_EE_DATA_HI) << 8) |
			    wl_mmiread(sc->wl_base, MMC_EE_DATA_LO);
	}
}

static void
wl_read_frequency_list(wl_softc_t * const sc)
{
	u_int16_t	table[10];	/* Authorized frequency table */
	long		freq = 0L;	/* offset from 2.4 GHz in .5 MHz with a 12 MHz bias */
	int		i;		/* index in the table */

	/* Read the frequency table */
	wl_eep_read(sc, 0x71 /* frequency table */, table, 10);

	/* Look at all frequencies */
	i = 0;
	for (freq = 0; freq < 150 && i < WL_MAXFREQS; freq++) {
		/* Look in the table if the frequency is allowed */
		if (table[9 - (freq / 16)] & (1 << (freq & 15))) {
			sc->wl_freqlist[i++] = 2400000 + ((freq + 24) * 500);
		}
	}
}

static
wl_canencrypt(sc)
	struct wl_softc *sc;
{
	int temp;
	temp = wl_mmiread(sc->wl_base, MMC_DES_AVAIL);
	return temp == MMC_DES_AVAIL_DES || temp == MMC_DES_AVAIL_AES;
}

static void
wl_encrypt(sc)
	struct wl_softc *sc;
{
	int i;

	if (sc->wl_doencrypt) {
		MMI_WRITE(MMC_ENCR_ENABLE, ENCR_ENABLE_EN | ENCR_ENABLE_MODE);
		for (i = 0; i <DES_KEY_SIZE; i++) {
			MMI_WRITE(MMC_ENCR_KEY+i, sc->wl_key[i]);
		}
	}
	else MMI_WRITE(MMC_ENCR_ENABLE, 0);
}

static void
wl_info_print(wl_softc_t * const sc)
{
	int i;

	if (!(sc->wl_flags & WL_MMI_INITED))
		return;
	
	/* Print additional info when attached. */
	printf("wl%d: address %s, nwid %02x%02x, ",
	    sc->wl_dev.dv_unit,
	    ether_sprintf(sc->wl_enaddr),
	    sc->wl_nwid[0], sc->wl_nwid[1]);
#if 0
	{
		unsigned tmp = wl_mmiread(sc->wl_base, MMC_EE_STATUS);
		printf("freq-eeprom %d (0x%02x), ", tmp >> 4, tmp);
	}
#endif
	if (wl_mmiread(sc->wl_base, MMC_EE_STATUS) & (EE_STATUS_DOWNLOAD|EE_STATUS_BUSY)) {
		unsigned comp_number = READ_PSA(PSA_COMP_NUMBER);
		/* printf("comp number: %x\n", comp_number); */
		if (comp_number & 1)
			printf("PC-MC ");
		else if (comp_number & 4)
			printf("PCMCIA ");
		else
			printf("PC-AT ");
		switch (READ_PSA(PSA_SUBBAND) & 15) {
		case 0: printf("915"); break;
		case 1: printf("2425"); break;
		case 2: printf("2460"); break;
		case 3: printf("2484"); break;
		case 4: printf("2430.5"); break;
		default: printf("???"); break;
		}
		printf(" MHz\n");
	} else {
		u_int16_t freq;

		/* Ask the EEprom to read the frequency from the first area */
		wl_eep_read(sc, 0x00, &freq, 1);	/* 1st area - frequency.. */
		sc->wl_freq = 2400000 + (freq >> 5) * 500;
		printf("%u.%u", sc->wl_freq / 1000000,
			(sc->wl_freq / 1000) % 1000);	/* Print frequency */
		if (sc->wl_freq % 1000)			/* Hack !!! */    
			printf("5");
		printf(" GHz\n");
		sc->wl_flags |= WL_V2CARD;
		wl_read_frequency_list(sc);
		if (sc->wl_freqlist[0] != 0) {
			printf("%s: supported frequencies (GHz):", sc->wl_if.if_name);
			for (i = 0; i < WL_MAXFREQS; i++) {
				if (sc->wl_freqlist[i] == 0)
					break;
				printf(" %u.%u", sc->wl_freqlist[i] / 1000000,
					(sc->wl_freqlist[i] / 1000) % 1000);
				if (sc->wl_freqlist[i] % 1000)
					printf("5");
			}
			printf("\n");
		}
		wl_modem_init(sc);
	}
	if (wl_canencrypt(sc)) {
#ifdef notdef
		printf("Encryption: %s  Key: %02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x\n",	
		READ_PSA(PSA_SECURITY_SELECT) ? "enabled" : "disabled",
		READ_PSA(PSA_ENCRYPTION_KEY), READ_PSA(PSA_ENCRYPTION_KEY+1),
		READ_PSA(PSA_ENCRYPTION_KEY+2), READ_PSA(PSA_ENCRYPTION_KEY+3),
		READ_PSA(PSA_ENCRYPTION_KEY+4), READ_PSA(PSA_ENCRYPTION_KEY+5),
		READ_PSA(PSA_ENCRYPTION_KEY+6), READ_PSA(PSA_ENCRYPTION_KEY+7));
#else
		printf("Encryption: available\n");
#endif
	}
	else printf("Encryption: not available\n");
}

static void
wl_modem_init(wl_softc_t * const sc)
{
	/* We must download the frequency parameters to the
	 * synthetisers (from the EEprom - area 1)
	 * Note : as the EEprom is auto decremented, we set the end
	 * if the area... */
	MMI_WRITE(MMC_EE_ADDR, 0x0F);
	MMI_WRITE(MMC_EE_CTRL, EE_CTRL_READ | EE_CTRL_DOWNLOAD);

	/* Wait until the download is finished */
	wl_eep_wait(sc, 100, 100);

	/* We must now download the power adjust value (gain) to
	 * the synthetisers (from the EEprom - area 7 - DAC) */
	MMI_WRITE(MMC_EE_ADDR, 0x61);
	MMI_WRITE(MMC_EE_CTRL, EE_CTRL_READ | EE_CTRL_DOWNLOAD);

	/* Wait until the download is finished */
	wl_eep_wait(sc, 100, 100);
}

/*
 * Probe routine
 */
/* ARGSUSED */
int
wl_probe(parent, cf, aux)
	struct device	*parent;
	struct cfdata	*cf;
	void		*aux;
{
	struct isa_attach_args *ia = (struct isa_attach_args *) aux;

	ia->ia_irq = IRQNONE;
	return (1);
}

/*
 * PCMCIA card service event handler (callback)
 */
int
wl_cse_handler(clidata, func, sock, info, mtdreq, buf, misc)
	void *clidata;
	int func, sock, info;
	struct mtdreq *mtdreq;
	char *buf;
	int misc;
{
	struct wl_softc *sc = (struct wl_softc *)clidata;

	switch (func) {
	case CSE_CARD_INSERTION:
		if (cu_configured(&sc->wl_clihdl, sock) || sc->wl_socket >= 0)
			break;
		if (wl_cc_probe(sc, sock))
			wl_cc_attach(sc, sock);
		break;

	case CSE_CARD_REMOVAL:
		wl_cc_detach(sc, sock);
		break;

	case CSE_CLIENT_INFO:
		break;

	default:
		break;
	}
	return 0;
}

/*
 * Probe routine called upon the card insertion event.
 *
 * Also check if the softc associated with this
 * client structure has a mac address set.
 * If so, check if the card probed has the same
 * mac address.
 */
int wl_cc_probe(struct wl_softc *sc, int sock) {
	cs_rtpl_t tplreq;
	int err;
	int base = -1, configured = 0, ret = 0;
	u_char tpccbuf[32];

#define USE_CS_SPEC_LOOKUP
#if defined(USE_CS_SPEC_LOOKUP)
	if (cs_spec_lookup(sock, "wl", NULL, 0)) {
		ccdprintf(("wl_cc_probe: no match by cs_spec_lookup\n"));
		return(0);
	}
#else

	tplreq.Socket = sock;
	tplreq.Desired = CISTPL_VERS_1;
	tplreq.TupleData = (u_char *)vbuf;
	tplreq.TupleDataMax = sizeof vbuf;

	if (err = cs_GetTuple(&tplreq)) {
		ccdprintf(("wl: can't read version 1 tuple\n"));
		return (0);
	}

	vlen = TupleLen(tplreq);
#if 0
	printf("wl_cc_probe: \"");
	for (cnt = 0; cnt < vlen; cnt++) {
		unsigned int ch = vbuf[cnt];
		printf((ch < ' ' || ch > '~') ? "\\%03o" : "%c", ch);
	}
	printf("\" (%d)\n", vlen);
#endif
	for (i = 0; i < NWLCCSTR; i++) {
		if (bcmp(vbuf, wl_ccstr[i].vstr, wl_ccstr[i].vlen) == 0)
			goto found;
	}
#if 0
	ccdprintf(("wl_cc_probe: no match\n")) ;
#endif
	return (0);

 found:;
#endif
	/*
	 * We would like to test if the card we are probing has been
	 * in the system before, but we can't do it before it is
	 * assigned its i/o ports.
	 */

	tplreq.Socket = sock;
	tplreq.Desired = CISTPL_CONF;
	tplreq.TupleData = tpccbuf;
	tplreq.TupleDataMax = sizeof tpccbuf;

	if ((err = cs_GetTuple(&tplreq))) {
		ccdprintf(("wl: can't find CISTPL_CONF, err 0x%x\n", err));
		return (0);
	}

	if ((err = cu_parse_conf(tpccbuf, TupleLen(tplreq), &sc->wl_tpcc))) {
		ccdprintf(("wl: bad CISTPL_CONF\n"));
		return (0);
	}

	ccdprintf(("wl: tpcc_radr 0x%x\n", sc->wl_tpcc.tpcc_radr)) ;
	ccdprintf(("wl: tpcc_rmsk 0x%x\n", sc->wl_tpcc.tpcc_rmsk[0])) ;

	sc->wl_rio.csrio_Socket = sock;
	sc->wl_rio.csrio_BasePort1 = 0;
	sc->wl_rio.csrio_NumPorts1 = WL_NPORT;
#if 0
	sc->wl_rio.csrio_PortAttr1 = CSRIO_DATAPATH_16;
#endif
	sc->wl_rio.csrio_PortAttr1 = 0;
	sc->wl_rio.csrio_IOAddrLines = 4;
	sc->wl_rio.csrio_NumPorts2 = 0;

	ccdprintf(("wl: Looking for I/O ports using CS ..."));

	if ((err = cs_RequestIO(&sc->wl_clihdl, &sc->wl_rio))) {
		ccdprintf(("wl: RequestIO err 0x%x\n", err));
		return (0);
	}
	ccdprintf((" done\n\tgot base 0x%x size 0%x\n",
		   sc->wl_rio.csrio_BasePort1,
		   sc->wl_rio.csrio_NumPorts1));

	base = sc->wl_rio.csrio_BasePort1;

	sc->wl_rcfg.cscfg_Socket = sock;
	sc->wl_rcfg.cscfg_Attributes = 0;	/* No interrupts yet. */
	sc->wl_rcfg.cscfg_Vcc = 50;		/* 5V to Vcc */
	sc->wl_rcfg.cscfg_Vpp1 = 50;
	sc->wl_rcfg.cscfg_Vpp2 = 50;
	sc->wl_rcfg.cscfg_IntType = CSCFG_IO;	/* I/O card */
	sc->wl_rcfg.cscfg_Present = CREGMAP_COR;
	sc->wl_rcfg.cscfg_ConfigBase = sc->wl_tpcc.tpcc_radr;
	sc->wl_rcfg.cscfg_ConfigIndex = COR_CONFIG | COR_SW_RESET;

	ccdprintf(("wl: (wl_cc_probe) Configuring using CS ...")) ;

	if ((err = cs_RequestConfiguration(&sc->wl_clihdl, &sc->wl_rcfg))) {
		printf("wl: RequestConfiguration err 0x%x\n", err);
	} else {
		ccdprintf((" done\n"));
		DELAY(200*1000);
		configured = 1;
		ret = 1;
		sc->wl_base = base;
	}

	/*
	 * Release the current configuration if configured.
	 */
	if (configured) {
		if ((err = cs_ReleaseConfiguration(&sc->wl_clihdl,
						  &sc->wl_rcfg)))
			printf("wl: ReleaseConfiguration err %d\n", err);
			/* Nothing else significant we can do. */
	}

	/*
	 * I/O window handling. Release the i/o window if returning error,
	 * otherwise record it for future use.
	 */
	if (ret == 0 && base >= 0) {
		if ((err = cs_ReleaseIO(&sc->wl_clihdl, &sc->wl_rio)))
			printf("wl: ReleaseIO err %d\n", err);
			/* Nothing else significant we can do. */
	}

	return (ret);
}

/*
 * Interface exists: make available by filling in network interface
 * record.  System will initialize the interface when it is ready
 * to accept packets.  We get the ethernet address here.
 */
int wl_cc_attach(struct wl_softc *sc, int sock) {
	struct ifnet *ifp = &sc->wl_if;
	int unit = ifp->if_unit;
	int i, err, irq, ivec;
	int configured, mac_select = 0, netw_addr, comp_number;
	u_char addr[WAVELAN_ADDR_SIZE];

	ccdprintf(("wl: base %x\n", sc->wl_base)) ;

	sc->wl_socket = sock;
	sc->wl_flags |= WL_SEATED;
#ifdef	TIMER
	sc->wl_timer = -1;
#endif	TIMER
	sc->wl_mode = 0;
	
	configured = READ_PSA(PSA_CONF_STATUS) & 1;
	if (!sc->wl_nwid[0]) sc->wl_nwid[0] = READ_PSA(NETW_ID);
	if (!sc->wl_nwid[1]) sc->wl_nwid[1] = READ_PSA(NETW_ID+1);
	if (configured) {
		mac_select = READ_PSA(PSA_MAC_SELECT) & 1;
		if (mac_select)
			netw_addr = NETW_ADDR_LOCAL;
		else
			netw_addr = NETW_ADDR; /* use factory assigned addr */
	}
	else
		netw_addr = NETW_ADDR;
#if 0
	printf("wl_cc_attach chooses netw_addr %x (%s); c:%d, m:%d\n", 
		netw_addr,
		netw_addr == NETW_ADDR ? "factory" : "local",
		configured,
		mac_select);
#endif

	for (i = 0; i < WAVELAN_ADDR_SIZE; i++)
		addr[i] = READ_PSA(netw_addr+i);

	if (EZERO(sc->wl_enaddr) || !ESAME(sc->wl_enaddr, addr)) {
		struct ifnet *ifp = &sc->wl_if;
		struct ifaddr *ifa;
		struct sockaddr_dl *sdl;

		/*
		 * This client is fresh. Can accept a new card.
		 */
		bcopy(addr, sc->wl_enaddr, sizeof sc->wl_enaddr);
		for (ifa = ifp->if_addrlist; ifa; ifa = ifa->ifa_next) {
		    if ((sdl = (struct sockaddr_dl *)ifa->ifa_addr) &&
		        sdl->sdl_family == AF_LINK) {
		        bcopy((caddr_t)((struct arpcom *)ifp)->ac_enaddr,
		              LLADDR(sdl), ifp->if_addrlen);
		  	break;
		    }
		}
	}

	/* turn on the power and check that the modem is connected
	 * before we attempt to access the Modem Management Interface.
	 */
	outb(HACR(sc->wl_base), HACR_PWR_STAT);
	DELAY(200*1000);

	/*
	 * Allocate an interrupt vector, configure together with base
	 * address, setup interrupt steering, and see if the card interrupts.
	 */

	/*
	 * Version 1a's CIS specifies IRQ 0 as only interrupt level
	 * it accepts.  This is ridiculous, and we are doing what we
	 * believe is correct here.  After all, cards are not aware
	 * of the actual interrupt level set in the adapter, we
	 * just can allocate what's available.
	 */
	sc->wl_rirq.Socket = sock;
	sc->wl_rirq.Attributes = CSRIRQ_TYPE_EXCLUSIVE;
	sc->wl_rirq.IRQInfo1 = CSIRQ_LEVEL | CSIRQ_MASKS;
	sc->wl_rirq.IRQInfo2 = 0xffff;
	if ((err = cs_RequestIRQ(&sc->wl_clihdl, &sc->wl_rirq))) {
		printf("wl_cc_attach: no irq (err: %d)\n", err);
		cs_ReleaseIO(&sc->wl_clihdl, &sc->wl_rio);
		sc->wl_base = 0;
		return (0);
	}

	if (sc->wl_rirq.AssignedIRQ == 0) {
		printf("wl_cc_attach: bad irq\n");
		cs_ReleaseIO(&sc->wl_clihdl, &sc->wl_rio);
		sc->wl_base = 0;
		return (0);
	}

	ivec = sc->wl_rirq.AssignedIRQ;
	irq = (1 << ivec);
	sc->wl_irq = irq;

#if 0
	sc->wl_rcfg.cscfg_Irqno = ffs(irq) - 1;
#endif
	sc->wl_rcfg.cscfg_Attributes = CSCFG_ENABLE_IRQ; /* Enable IRQ */
	sc->wl_rcfg.cscfg_Vcc = 50;		/* 5V to Vcc */
	sc->wl_rcfg.cscfg_Vpp1 = 50;
	sc->wl_rcfg.cscfg_Vpp2 = 50;
	sc->wl_rcfg.cscfg_IntType = CSCFG_IO;	/* I/O card */
	sc->wl_rcfg.cscfg_Present = CREGMAP_COR;
	sc->wl_rcfg.cscfg_ConfigBase = sc->wl_tpcc.tpcc_radr;
	sc->wl_rcfg.cscfg_ConfigIndex = COR_CONFIG;

	ccdprintf(("wl: (wl_cc_attach) Configuring using CS ...")) ;

	if ((err = cs_RequestConfiguration(&sc->wl_clihdl, &sc->wl_rcfg))) {
		printf("wl: RequestConfiguration err 0x%x\n", err);
		cs_ReleaseIO(&sc->wl_clihdl, &sc->wl_rio);
		cs_ReleaseIRQ(&sc->wl_clihdl, &sc->wl_rirq);
		sc->wl_base = 0;
		return (0);
	} else {
		ccdprintf((" done\n"));
		DELAY(200*1000);
	}

	ccdprintf(("wl_cc_attach: irq %x (ivec %d)\n", irq, ivec)) ;

	/*
	 * At this point, the COR has been written with the value
	 * COR_CONFIG. Toggling the lock-out flag should work. In
	 * addition, the NO_CLK flag should be clear. Try it.
	 */
	outb(HACR(sc->wl_base), HACR_PWR_STAT | HACR_LOF);
	i = inb(HASR(sc->wl_base)); 
	if ((i & HASR_LOF) != HASR_LOF) {
		ccdprintf(("wl_cc_attach: LOF not set (%x)\n", i));
	}
	if ((i & HASR_NO_CLK) != 0) {
		ccdprintf(("wl_cc_attach: no clock (%x)\n", i));
	}
	outb(HACR(sc->wl_base), HACR_PWR_STAT);
	i = inb(HASR(sc->wl_base)); 
	if ((i & HASR_LOF) != 0) {
		ccdprintf(("wl_cc_attach: LOF not clear (%x)\n", i));
	}
	if ((i & HASR_NO_CLK) != 0) {
		ccdprintf(("wl_cc_attach: no clock (%x)\n", i));
	}

	dyna_intr_establish(irq, &sc->wl_ih, DV_NET);

#if 0
	sc->wl_ats.func = efshutdown;
	sc->wl_ats.arg = (void *)sc;
	atshutdown(&sc->wl_ats, ATSH_ADD);
#endif

	sc->wl_flags |= WL_ATTACHED;
	if ((sc->wl_flags & WL_INIT_DEFERRED)) {
		wl_init(unit);
	}

	wl_info_print(sc);

	return (1);
}

int wl_cc_detach(struct wl_softc *sc, int sock) {
	if (sc->wl_socket != sock)
		return 0;

	if (sc->wl_socket < 0)	/* sanity */
		return 0;

	sc->wl_socket = -1;
	sc->wl_flags &= ~WL_ATTACHED;
	sc->wl_flags &= ~WL_MMI_INITED;
	sc->wl_flags |= WL_INIT_DEFERRED;
	sc->wl_if.if_flags &= ~IFF_RUNNING;

	dyna_intr_release(sc->wl_irq, &sc->wl_ih);
	cs_ReleaseConfiguration(&sc->wl_clihdl, &sc->wl_rcfg);
	cs_ReleaseIO(&sc->wl_clihdl, &sc->wl_rio);
	cs_ReleaseIRQ(&sc->wl_clihdl, &sc->wl_rirq);

#if 0
	printf("wl: wl_cc_detach(), flags %08x\n", sc->wl_flags);
#endif
	return 1;
}

/*
 * wl_attach: this is a dummy routine that make the system think
 * there's an interface.  Make the interface (virtually) visilble
 * by filling in the network interface record.  Also register with
 * socket driver to inform us in the event of card insertion.
 */
/* ARGSUSED */
void
wl_attach(parent, self, aux)
	struct device *parent;
	struct device *self;
	void *aux;
{
	struct wl_softc *sc = (struct wl_softc *) self;
	int unit = sc->wl_dev.dv_unit;
	struct ifnet *ifp = &sc->wl_if;
	cs_rclient_t rcli;
	struct ifreq ifreq;

	/*
	 * Initialize interface structure
	 */
	ifp->if_unit = unit;
	ifp->if_name = wlcd.cd_name;
	ifp->if_mtu = ETHERMTU;
	ifp->if_flags = IFF_BROADCAST | IFF_SIMPLEX | IFF_NOTRAILERS;
#ifdef MULTICAST
	ifp->if_flags |= IFF_MULTICAST;
#endif
	ifp->if_init = wl_init;
	ifp->if_start = wl_start;
	ifp->if_ioctl = wl_ioctl;
	ifp->if_watchdog = 0;
	ether_attach(ifp);

#ifdef MULTICAST
	bzero(&ifreq, sizeof(ifreq));
        ifreq.ifr_addr.sa_family = AF_UNSPEC;
        bcopy((caddr_t)beaconindaddr, ifreq.ifr_addr.sa_data, sizeof(beaconindaddr));
        ether_addmulti(&ifreq, &sc->wl_ac);
#endif

#if NBPFILTER > 0
	bpfattach(&ifp->if_bpf, ifp, DLT_EN10MB, sizeof(struct ether_header));
#endif

	bzero(sc->wl_enaddr, sizeof sc->wl_enaddr);
	sc->wl_socket = -1;
	sc->wl_ih.ih_fun = wl_intr;
	sc->wl_ih.ih_arg = sc;
	sc->wl_flags |= WL_INIT_DEFERRED;

	rcli.Attributes = CSCLI_IO;
	rcli.EventMask = ~CSEM_CD_CHANGE;
	rcli.CallBack = wl_cse_handler;
	rcli.CallBackArg = sc;

	cs_RegisterClient(&sc->wl_clihdl, &rcli) ;

	isa_establish(&sc->wl_id, &sc->wl_dev);

	printf(": PCCARD ethernet (WaveLAN)\n") ;
}

void
wl_initmmi(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int conf_status = READ_PSA(PSA_CONF_STATUS);
	int configured = conf_status & 1;

	if ((sc->wl_flags & WL_MMI_INITED))
		return;

  	/* Set default modem control parameters.  Taken from NCR document
	   407-0024326 Rev. A */
	MMI_WRITE(MMC_JABBER_ENABLE, 0x01);
	MMI_WRITE(MMC_ANTEN_SEL, 0x02);
	MMI_WRITE(MMC_IFS, 0x20);
	MMI_WRITE(MMC_MOD_DELAY, 0x04);
	MMI_WRITE(MMC_JAM_TIME, 0x38);
	MMI_WRITE(MMC_DECAY_PRM, 0x00);	/* obsolete ? */
	MMI_WRITE(MMC_DECAY_UPDAT_PRM, 0x00);
	if (!configured) {
		if (!(sc->wl_flags & WL_ALLNWID_MODE)) {
			MMI_WRITE(MMC_LOOPT_SEL, 0x00);
		} else {
			MMI_WRITE(MMC_LOOPT_SEL, 0x40);
		}
		MMI_WRITE(MMC_THR_PRE_SET, 0x03); /* 0x03 for PCMCIA */
		MMI_WRITE(MMC_QUALITY_THR, 0x03);
	} else {
		/* Use configuration defaults from parameter storage area. */
		if ((READ_PSA(PSA_NETW_ID_SELECT) & 1) && !(sc->wl_flags & WL_ALLNWID_MODE)) {
			MMI_WRITE(MMC_LOOPT_SEL, 0x00);
		} else {
			MMI_WRITE(MMC_LOOPT_SEL, 0x40);	/* disable network id check */
		}
		MMI_WRITE(MMC_THR_PRE_SET, READ_PSA(PSA_THR_PRE_SET) & 0x3f);
		MMI_WRITE(MMC_QUALITY_THR, READ_PSA(PSA_QUALITY_THR) & 0x0f);
	}
	MMI_WRITE(MMC_FREEZE, 0x00);
	wl_encrypt(sc);
	MMI_WRITE(MMC_DES_IO_INVERT, 0);
	
	MMI_WRITE(MMC_NETW_ID_L, sc->wl_nwid[1]); /* set NWID */
	MMI_WRITE(MMC_NETW_ID_H, sc->wl_nwid[0]);

	MMI_WRITE(MMC_MODE_SEL, 0x00);
	sc->wl_flags |= WL_MMI_INITED;

	if (!configured && (READ_PSA(PSA_CONF_STATUS) & 1)) {
		printf("MMI changed to configured\n");
	}
}

u_short
wl_mmiread(int base, u_short reg) {
	while (inb(HASR(base)) & HASR_MMI_BUSY)
		;
	outb(MMR(base), reg << 1);
	outb(MMD(base), 0);	/* dummy write */
	while (inb(HASR(base)) & HASR_MMI_BUSY)
		;
	return ((u_short) inb(MMD(base)));
}


/* update various fields from the MMC registers */
void
update_mmc_status(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;
	u_short tmp;

	/* MMC status 
	 */
	sc->wl_cntrs.mmc.dce_status = wl_mmiread(base, MMC_DCE_STATUS);

	/* # of correct NWIDs received; read high before low
	 */
	tmp = wl_mmiread(base, MMC_CORRECT_NWID_H) << 8;
	tmp |= wl_mmiread(base, MMC_CORRECT_NWID_L);
	sc->wl_cntrs.mmc.nwids = tmp;

	/* # of wrong NWIDs received; read high before low
	 */
	tmp = wl_mmiread(base, MMC_WRONG_NWID_H) << 8;
	tmp |= wl_mmiread(base, MMC_WRONG_NWID_L);
	sc->wl_cntrs.mmc.badnwids = tmp;
}

#ifdef MMC_STATUS
 
/* print various fields from the MMC registers */
void
print_mmc_status(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	u_int N = 3; 
	u_int call_count = 0;

	/* update the MMC status
	 */
	update_mmc_status(unit);

	/* print status 
	 */
	if (!call_count) { /* we only print once every N calls */
		printf("MMC Status: %d; # good NWIDs: %d; # bad NWIDs: %d; NWID: %x%x\n",
		       sc->wl_cntrs.mmc.status, sc->wl_cntrs.mmc.nwids,
		       sc->wl_cntrs.mmc.badnwids, sc->wl_nwid[0], sc->wl_nwid[1]);
	}
	call_count = (call_count + 1) % N;
}

#endif /* MMC_STATUS */

/*
 * wl_init:
 *
 *	Another routine that interfaces the "if" layer to this driver.  
 *	Simply resets the structures that are used by "upper layers".  
 *	As well as calling wl_hwrst that does reset the WaveLAN board.
 *
 * input	: board number
 * output	: structures (if structs) and board are reset
 *
 */	
static
wl_init(int unit) {
	struct wl_softc *sc = WLPSOFTC(unit);
	struct ifnet *ifp;
	int stat, s;

	ccdprintf(("wl%d: entered wl_init(), cpl %x\n", unit, cpl));

	/* The card might have been ejected. */
	if (sc == 0)
		return (FALSE);
	if (!(sc->wl_flags & WL_ATTACHED)) {
		sc->wl_flags |= WL_INIT_DEFERRED;
		return(FALSE);
	}
	sc->wl_flags &= ~WL_INIT_DEFERRED;

	ifp = &WLPIF(unit);
	if ((stat = wl_hwrst(unit)) == TRUE) {
		s = SPLNET();
#ifdef	TIMER
		timeout(wl_watch, &(ifp->if_unit), 5*hz);
		sc->wl_timer = 5;
#endif	TIMER
		WLPIF(unit).if_flags |= IFF_RUNNING;
		sc->wl_flags |= WL_RUNNING;
		sc->wl_flags &= ~WL_TBUSY;
		sc->wl_flags &= ~WL_CMD_REQUEST;
		sc->wl_flags &= ~WL_CMD_WAIT;
		sc->wl_flags &= ~WL_DEFERRED;
		wl_start(ifp);
		splx(s);
	} else {
		printf("wl%d init(): trouble resetting board.\n", unit);
	}
	return (stat);
}

/*
 * wl_hwrst:
 *
 *	This routine resets the WaveLAN board that corresponds to the 
 *	board number passed in.
 *
 * input	: board number to do a hardware reset
 * output	: board is reset
 *
 */
wl_hwrst(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;

	ccdprintf(("wl%d: entered wl_hwrst()\n", unit));

	/* reset host adapter */
	outb(HACR(base), 
	     HACR_PWR_STAT | HACR_TX_DMA_RESET | HACR_RX_DMA_RESET);
	sc->wl_flags &= ~WL_POWER_DOWN;
	if (inb(HASR(base)) & HASR_NO_CLK) {
		printf("wl%d: modem not connected. \n", unit);
		return (FALSE);
	}

	outb(LCCR(base), OP0_RESET); /* reset the LAN controller */
	DELAY(100 * 1000);

	/* initialize modem */
	wl_initmmi(unit);

	if (wl_config(unit) == FALSE)
		return (FALSE);

	/* 
	 * insert code for loopback test here
	 *
	 */
	wl_rustrt(unit);	/* start receive unit */

	return(TRUE);
}

/*
 * wl_start:
 *
 *	This is yet another interface routine that simply tries to output a
 *	in a packet after a reset.
 *
 * input	: board number
 * output	: stuff sent to board if any there
 */
int
wl_start(struct ifnet *ifp) {
	int unit = ifp->if_unit;
	wl_softc_t *sc = WLPSOFTC(unit);
        struct mbuf *m;
	int base;

	ccdprintf(("wl%d: entered wl_start() qlen %d\n",
		   unit, ifp->if_snd.ifq_len));

	/* The card might have been ejected. */
	if (sc == 0)
		return;

	base = sc->wl_base;

	/* XXX the following is a debug statement, remove for efficiency. */
#if 0
	if ((sc->wl_flags & WL_CMD_REQUEST))
		printf("wl_start called with cmd_request=%d deferred=%d\n",
		       (sc->wl_flags & WL_CMD_REQUEST) == WL_CMD_REQUEST,
		       (sc->wl_flags & WL_DEFERRED) == WL_DEFERRED);
#endif
	if ((sc->wl_flags & WL_TBUSY) || (sc->wl_flags & WL_POWER_DOWN))
		return (0);

	IF_DEQUEUE(&ifp->if_snd, m);
	if (m != 0) {
#if NBPFILTER > 0
		if (ifp->if_bpf)
			bpf_mtap(ifp->if_bpf, m);
#endif
		sc->wl_flags |= WL_TBUSY;
		sc->wl_cntrs.xmt.xmt++;
		ifp->if_opackets++;
		wl_xmt(unit, m);
	}

	return (0);
}

/* return the starting address of the frame pointed to by the
   receive frame pointer */
static int
wl_start_of_frame(int unit, int rfp) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;
	int rp, len, len1, len_ptr;
	unsigned char c;
     
	rp = (rfp - 5 + RX_SIZE) % RX_SIZE;
	outb(PIORL(base), rp & 0xff);
	outb(PIORH(base), ((rp >> 8) & PIORH_MASK));
	len = inb(PIOP(base));
	len |= inb(PIOP(base)) << 8;
     
	len_ptr = rp;
	len_ptr = read_ringbuf(unit, len_ptr, (char*) &c, 1);
	len1 = c;
	len_ptr = read_ringbuf(unit, len_ptr, (char*) &c, 1);
	len1 |= c << 8;
	if(len != len1 || len > 1600)
		ccdprintf(("oops, rfp %d rp %d len 0x%x len1 0x%x\n", rfp, rp, len, len1));
	if(len > 1600)
		return (-1);
	else
		return ((rp - len + RX_SIZE) % RX_SIZE);
}

/*
 * wl_rcv:
 *
 *	This routine is called by the interrupt handler to initiate a
 *	packet transfer from the board to the "if" layer above this
 *	driver.  This routine checks if a buffer has been successfully
 *	received by the WaveLAN.  If so, the routine wl_read is called
 *	to do the actual transfer of the board data (including the
 *	ethernet header) into a packet (consisting of an mbuf chain).
 *
 * input	: number of the board to check
 * output	: if a packet is available, it is "sent up"
 *
 */

#if 1
int      dbg_newrfp[10];
int      dbg_rfp[10];
int      dbg_stop[10];
int      dbg_i593rfp[10];
#endif

wl_rcv(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;
	int newrfp, rp, len, f_start, lastframe_start, status;
	int i593_rfp, stat_ptr, sanity;
	unsigned char c;
#if 1
	static int i = 0;
#endif
     
	ccdprintf(("wl%d: entered wl_rcv()\n", unit));
     
	/* get the new receive frame pointer from the i82593 chip */
	outb(LCCR(base), CR0_STATUS_2 | OP0_NOP);
	i593_rfp = inb(LCSR(base));
	i593_rfp |= inb(LCSR(base)) << 8;
	i593_rfp %= RX_SIZE;
     
	/* Get the new receive frame pointer from the WaveLAN host adapter.
	 * It is 3 bytes more than the increment of the i82593 receive
	 * frame pointer, for each packet.
	 */
	newrfp = inb(RPLL(base));
	newrfp |= inb(RPLH(base)) << 8;
	newrfp %= RX_SIZE;
#if 1
	dbg_rfp[i] = sc->wl_rfp;
	dbg_newrfp[i] = newrfp;
	dbg_stop[i] = sc->wl_stop;
	dbg_i593rfp[i] = i593_rfp;
	i = (i + 1) % 10;
#endif
	if ((sc->wl_flags & WL_OVERRUNNING)) {
		/* 
		 * Data is arriving at a rapid rate and the receive frame is  
		 * full. So, drop the last frame and reset the frame pointers.
		 */
#ifdef DEBUG
		printf("Overrunning... newrfp %d, sc->wl_rfp %d\n", 
		       newrfp, sc->wl_rfp);
		if (newrfp == sc->wl_rfp)
			printf("Receiver pointers also equal...\n");
#endif

		lastframe_start = wl_start_of_frame(unit, newrfp);
		if (lastframe_start == -1) {
#ifdef DEBUG
			printf("wl%d: receive buffer overflow & cannot find start of frame\n");
			printf(" i593_rfp %d stop %d newrfp %d sc->wl_rfp %d\n",
			       i593_rfp, sc->wl_stop, newrfp, sc->wl_rfp);
#endif
		} else {
			newrfp = lastframe_start;
#ifdef DEBUG
			printf("Found start of last-but-one frame\n");
			printf("newrfp now = %d, sc->wl_rfp = %d\n", newrfp, sc->wl_rfp);
#endif
			/* this used to set overrunning = !overrunning */
			sc->wl_flags &= ~WL_OVERRUNNING;
		}
	}

	if ((sc->wl_flags & WL_OVERRUNNING) || (newrfp == sc->wl_rfp)) {
		/*
		 * This can occur only if we couldn't
		 * find start of last frame.
		 */
#ifdef DEBUG
		printf("wl%d: odd RFPs:\n", unit);
		printf(" i593_rfp %d stop %d newrfp %d sc->wl_rfp %d\n",
		       i593_rfp, sc->wl_stop, newrfp, sc->wl_rfp);
		for (k = i; k < 10; k++)
			printf("newrfp %d sc->wl_rfp %d, i593_rfp %d stop %d\n",
			       dbg_newrfp[k], dbg_rfp[k],
			       dbg_i593rfp[k], dbg_stop[k]);
		if (i != 0)
			for (k = 0; k < i; k++)
				printf(
				 "newrfp %d sc->wl_rfp %d, i593_rfp %d stop %d\n",
				       dbg_newrfp[k], dbg_rfp[k],
				       dbg_i593rfp[k], dbg_stop[k]);
#endif
	}
     
	while (newrfp != sc->wl_rfp) {
		rp = newrfp;
		/* find first frame */
		sanity = 0;
		while ((f_start = wl_start_of_frame(unit,rp)) != sc->wl_rfp) {
			if (f_start == -1 || sanity++ > 200) {
#ifdef DEBUG
				printf("wl%d: cannot find start of frame\n",
				       unit);
				printf(
				 " i593_rfp %d stop %d newrfp %d sc->wl_rfp %d\n",
				       i593_rfp, sc->wl_stop, newrfp, sc->wl_rfp);
				for (k = i; k < 10; k++)
					printf(
				"newrfp %d sc->wl_rfp %d,  i593_rfp %d stop %d\n",
					       dbg_newrfp[k], dbg_rfp[k],
					       dbg_i593rfp[k], dbg_stop[k]);
				if (i != 0)
					for (k = 0; k < i; k++)
						printf(
				"newrfp %d sc->wl_rfp %d,  i593_rfp %d stop %d\n",
						       dbg_newrfp[k],
						       dbg_rfp[k],
						       dbg_i593rfp[k],
						       dbg_stop[k]); 
#endif
				return;
			}
			rp = f_start;
		}
	  
		stat_ptr = (rp - 7 + RX_SIZE) % RX_SIZE;
		stat_ptr = read_ringbuf(unit, stat_ptr, (char*) &c, 1);
		status = c;
		stat_ptr = read_ringbuf(unit, stat_ptr, (char*) &c, 1);
		status |= c << 8;
		stat_ptr = read_ringbuf(unit, stat_ptr, (char*) &c, 1);
		len = c;
		stat_ptr = read_ringbuf(unit, stat_ptr, (char*) &c, 1);
		len |= c << 8;
	  
		if (!(status & RX_RCV_OK)) {
			if (status & RX_NO_SFD) {
				sc->wl_cntrs.rcv.frame++;
				ccdprintf(("No Start of Frame Detector\n"));
			}
			if (status & RX_CRC_ERR) {
				sc->wl_cntrs.rcv.crc++;
				ccdprintf(("CRC error\n"));
			}
			if (status & RX_OVRRUN) {
				sc->wl_cntrs.rcv.ovrnerrs++;
				ccdprintf(("Receive overrun\n"));
			}
			ccdprintf(("wl%d: packet not rcvd ok, status = %x\n",
				   unit, status)); 
			WLPIF(unit).if_ierrors++;
		} else {
			WLPIF(unit).if_ipackets++;
			wl_read(unit, f_start, len - 2);
		}
		sc->wl_rfp = rp;
	}
	
	/*
	 * Update the frame stop register, but set it to less than
	 * the full 8K to allow space for 3 bytes of signal strength
	 * per packet.
	 */
	sc->wl_stop = (i593_rfp + RX_SIZE - ((RX_SIZE / 64) * 3)) % RX_SIZE;
	outb(LCCR(base), OP0_SWIT_TO_PORT_1 | CR0_CHNL);
	outb(LCCR(base), CR1_STOP_REG_UPDATE | (sc->wl_stop >> RX_SIZE_SHIFT));
	outb(LCCR(base), OP1_SWIT_TO_PORT_0);
}

/*
 * wl_read:
 *
 *	This routine does the actual copy of data (including ethernet header
 *	structure) from the WaveLAN to an mbuf chain that will be passed up
 *	to the "if" (network interface) layer.  NOTE:  we currently
 *	don't handle trailer protocols, so if that is needed, it will
 *	(at least in part) be added here.  The contents of the receive
 *	buffer are copied to an message chain that is then enqueued onto
 *	the appropriate "if" queue.
 *
 * input	: board number, and an frame descriptor address
 * output	: the packet is put into an ipc_kmsg, and passed up
 * assumes	: if any errors occur, packet is "dropped on the floor"
 *
 */
wl_read(int unit, int fd_p, int len) {
	wl_softc_t *sc = WLPSOFTC(unit);
	struct ifnet *ifp = &WLPIF(unit);
	int base = sc->wl_base;
	struct mbuf *m, *tm;
	u_char *mb_p;
	u_short mlen;
	u_short bytes_in_msg, bytes_in_mbuf, bytes;
	struct ether_header eh;
	u_char siglvl, sillvl, sigqual;

	ccdprintf(("wl%d: entered wl_read() fd_p 0x%x len %d\n",
		   unit, fd_p, len));
	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {
	    ccdprintf(("wl%d read(): board is not running.\n", ifp->if_unit));
		/* XXX turn off interrupts? */
	    return(0);
	}
	sc->wl_cntrs.rcv.rcv++;

	/*
	 * Get ether header.
	 */
	fd_p = read_ringbuf(unit, fd_p, (char *) &eh, sizeof(eh));

	MGETHDR(m, M_DONTWAIT, MT_DATA);
	tm = m;
	if (m == (struct mbuf *)0) {
		/*
		 * Not only do we want to return, we need to drop the packet
		 * on the floor to clear the interrupt.
		 */
		return (1);
	}

	m->m_next = (struct mbuf *)0;
	m->m_pkthdr.rcvif = ifp;
	m->m_pkthdr.len = len - sizeof(struct ether_header);
	m->m_len = MHLEN;
	bytes_in_msg = len - sizeof(struct ether_header);
	if (bytes_in_msg >= MINCLSIZE) {
		MCLGET(m, M_DONTWAIT);
		if (m->m_flags & M_EXT)
			m->m_len = MCLBYTES;
	}
	mlen = 0;
	bytes_in_mbuf = m->m_len;
	mb_p = mtod(tm, u_char *);
	for (;;) {
		bytes = min(bytes_in_mbuf, bytes_in_msg);
		fd_p = read_ringbuf(unit, fd_p, (char*) mb_p, bytes);

		mlen += bytes;

		if (!(bytes_in_msg -= bytes)) {
			tm->m_len = mlen;
			break;
		}

		MGET(tm->m_next, M_DONTWAIT, MT_DATA);
		tm = tm->m_next;
		if (tm == (struct mbuf *)0) {
			m_freem(m);
			printf("wl%d read(): No mbuf nth\n", unit);
			return (0);
		}
		mlen = 0;
		tm->m_len = MLEN;
		bytes_in_mbuf = MLEN;
		mb_p = mtod(tm, u_char *);
	}

	/* get SNR info for access point beacon.ind messages
	 */
	if ((sc->wl_flags & WL_GATHER_SNR) && (bcmp(eh.ether_dhost, beaconindaddr,
			       sizeof(eh.ether_dhost)) == 0)) {
		/* skip status and len fields */
		fd_p = read_ringbuf(unit, fd_p, NULL, 4);
		/* read signal level, silence level and signal quality bytes */
		fd_p = read_ringbuf(unit, fd_p, (char*) &siglvl, 1);
		fd_p = read_ringbuf(unit, fd_p, (char*) &sillvl, 1);
		fd_p = read_ringbuf(unit, fd_p, (char*) &sigqual, 1);
		wl_getsnr(unit,&eh,siglvl,sillvl,sigqual);
	}

#if NBPFILTER > 0
	/*
	 * Send to the packet filter if necessary. Also, if the
	 * interface is in promiscuous mode, don't send the
	 * wrong packets to ether_input().
	 * Check if there's a bpf filter listening on this interface.
	 * If so, hand off the raw packet to bpf, which must deal with
	 * trailers in its own way.
	 */
	if (ifp->if_bpf) {
		struct mbuf m0;

		m0.m_data = (char*) &eh;
		m0.m_len = sizeof(eh);
		m0.m_next = m;

		bpf_mtap(ifp->if_bpf, &m0);
		
		/*
		 * Note that the interface cannot be in promiscuous
		 * mode if there are no bpf listeners.  And if we are
		 * in promiscuous mode, we have to check if this
		 * packet is really ours.
		 */
		if ((ifp->if_flags & IFF_PROMISC) &&
		    bcmp(eh.ether_dhost, sc->wl_enaddr,
			 sizeof(eh.ether_dhost)) != 0 &&
#ifdef MULTICAST
			/* non-multicast (also non-broadcast) */
			!ETHER_IS_MULTICAST(eh.ether_dhost)
#else
			bcmp(eh.ether_dhost, etherbroadcastaddr, 
			     sizeof(eh.ether_dhost)) != 0
#endif
		    ) {
			m_freem(m);
			return 1;
		}
	}
#endif

#ifdef IF_CNTRS
	wl_ifcntrs.pkt_ein[log_2(len)]++;
	if (len < 128)
		wl_ifcntrs.pkt_lin[len>>3]++;

	if (ehp->ether_type == ETHERTYPE_ARP) {
		wl_ifcntrs.pkt_arp++;
		if (pkt_narp) {
			wl_ifcntrs.pkt_ein[log_2(len)]--;
			if (len < 128) wl_ifcntrs.pkt_lin[len>>3]--;
		}
	}
#endif IF_CNTRS

	/*
	 * Hand the packet to the Network Module
	 */
	eh.ether_type = ntohs(eh.ether_type);
	ether_input(&WLPIF(unit), &eh, m);
	return (1);
}

/*
 * Read len bytes from ring buffer, starting at address addr.
 * Result is stored in buf.  Return value is addr to be used for next call.
 */
int
read_ringbuf(int unit, int addr, char *buf, int len) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;
	int ring_ptr, chunk_len;
	char *buf_ptr;

	buf_ptr = buf;
	ring_ptr = addr;

	/* if buf is NULL, just increment the ring buffer pointer */
	if (buf == NULL)
		return ((ring_ptr - RX_BASE + len) % RX_SIZE + RX_BASE);
	while (len > 0) {
		/* position Program I/O Register at ring buffer pointer */
		outb(PIORL(base), ring_ptr & 0xff);
		outb(PIORH(base), (ring_ptr >> 8) & PIORH_MASK);
		/* determine how much we can read without wrapping around */
		if (addr + len < RX_BASE + RX_SIZE)
			chunk_len = len;
		else
			chunk_len = RX_BASE + RX_SIZE - addr;
		linb(PIOP(base), buf_ptr, chunk_len);
		buf_ptr += chunk_len;
		len -= chunk_len;
		ring_ptr = (ring_ptr - RX_BASE + chunk_len)
			   % RX_SIZE + RX_BASE;
	}
	return (ring_ptr);
}  

#ifdef TIMER
/*
 * wl_watch():
 *
 *	This routine is the watchdog timer routine for the WaveLAN chip.  If
 *	chip wedges, this routine will fire and cause a board reset and
 *	begin again.
 *
 * input	: which board is timing out
 * output	: potential board reset if wedged
 *
 */
static int watch_dead = 0;
wl_watch(caddr_t b_ptr) {
	int s, unit = *b_ptr;

	if ((WLPIF(unit).if_flags & IFF_UP) == 0)
		return;
	if (sc->wl_timer == -1) {
		timeout(wl_watch, b_ptr, 5*hz);
		return;
	}
	if (--sc->wl_timer != -1) {
		timeout(wl_watch, b_ptr, 1*hz);
		return;
	}

	s = SPLNET();
	ccdprintf(("wl%d watch(): 6sec timeout no %d\n", unit, ++watch_dead));
	sc->wl_cntrs.watch++;
	if (wl_hwrst(unit) != TRUE) {
		printf("wl%d watch(): hwrst trouble.\n", unit);
		sc->wl_timer = 0;
	} else {
		timeout(wlwatch, b_ptr, 1*hz);
		sc->wl_timer = 5;
	}
	splx(s);
}
#endif	TIMER

/*
 * Gracefully turn off reception, and wait for any commands to complete
 */
static
wl_graceful_shutdown(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;
	int status;
  
	wl_cmd(unit, "wl_graceful_shutdown(): stop-rcv",
	       OP0_STOP_RCV, SR0_NO_RESULT);
	/* spin until the receive unit is idle */
	do {
		int s = SPLNET();

		outb(LCCR(base), OP0_NOP | CR0_STATUS_3);
		status = inb(LCSR(base));
		splx(s);
	} while((status & SR3_RCV_STATE_MASK) != SR3_RCV_IDLE);
		       
	sc->wl_flags |= WL_CMD_REQUEST;	/* signal that we want to issue a command */
	/* spin until the chip finished executing any current command */
	do {
		int s = SPLNET();

		outb(LCCR(base), OP0_NOP | CR0_STATUS_3);
		status = inb(LCSR(base));
		splx(s);
	} while ((status & SR3_EXEC_STATE_MASK) != SR3_EXEC_IDLE);
	sc->wl_flags &= ~WL_CMD_REQUEST;
}

/*
 * wl_rustrt:
 *
 *	This routine starts the receive unit running.  First checks if the
 *	board is actually ready, then the board is instructed to receive
 *	packets again.
 */
wl_rustrt(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;

	ccdprintf(("wl%d: entered wl_rustrt()\n", unit));

	/* XXX check if board is running here? */

	/* First disable reception in case it was already enabled */
	wl_graceful_shutdown(unit);

	/* We now know that no command is being executed. */

	/* set the receive frame pointer and stop pointer */
	sc->wl_rfp = 0;
	outb(LCCR(base), OP0_SWIT_TO_PORT_1 | CR0_CHNL);
	/* Reset ring management.  This sets the receive frame pointer to 1 */
	outb(LCCR(base), OP1_RESET_RING_MNGMT);
#if 0
	/* XXX the manual page 6-4 seems to indicate that the stop register
	   should be set as below */
	/* outb(LCCR(base), CR1_STOP_REG_UPDATE |
		((RX_SIZE - 0x40) >> RX_SIZE_SHIFT)); */
#elif 0
	/* but I set it 0 instead */
	sc->wl_stop = 0;
#else
	/* but I set it to 3 bytes per packet less than 8K */
	sc->wl_stop = (0 + RX_SIZE - ((RX_SIZE / 64) * 3)) % RX_SIZE;
#endif
	outb(LCCR(base), CR1_STOP_REG_UPDATE | (sc->wl_stop >> RX_SIZE_SHIFT));
	outb(LCCR(base), OP1_INT_ENABLE);
	outb(LCCR(base), OP1_SWIT_TO_PORT_0);

	/* reset receive DMA pointer */
	outb(HACR(base), HACR_PWR_STAT | HACR_RX_DMA_RESET);
	DELAY(1000);
	outb(HACR(base), HACR_PWR_STAT);
	DELAY(1000);

	/* receive DMA on channel 1 */
	wl_cmd(unit, "wl_rustrt(): rcv-enable",
	       CR0_CHNL | OP0_RCV_ENABLE, SR0_NO_RESULT);
	return;
}

/*
 * wl_diag:
 *
 *	This routine does a 593 op-code number 7, and obtains the
 *	diagnose status for the WaveLAN.
 */
wl_diag(int unit) {

	ccdprintf(("wl%d: entered wl_diag()\n", unit));
	if(wl_cmd(unit, "wl_diag(): diagnose",
		  OP0_DIAGNOSE, SR0_DIAGNOSE_PASSED))
		return (TRUE);
	printf("wl%d: i82593 Self Test failed!\n", unit);
	return (FALSE);
}

/*
 * wl_config:
 *
 *	This routine does a standard config of the WaveLAN board.
 */
wl_config(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
        struct ifnet *ifp = &WLPIF(unit);
	int base = sc->wl_base;
#if MULTICAST
	int cnt = 0;
	struct ether_multi *enm;
	struct ether_multistep step;
#endif

#define matt
	ccdprintf(("wl%d: wl_config(), size %d\n",
		   unit, sizeof(struct i82593)));

	bzero(&sc->wl_cfblk, sizeof(struct i82593));
	sc->wl_cfblk.forgnesi = FALSE;	/* 0=82C501, 1=AMD7992B compatibility */
	sc->wl_cfblk.d6mod = FALSE;	/* Run in 82593 advanced mode */
	if (ifp->if_flags & IFF_LINK0)
		sc->wl_cfblk.loopback = 1; /* internal loopback */

	/* variable stuff
	 */
#ifdef matt
	sc->wl_cfblk.fifo_limit = 5;	/* = 32 byte rx/tx fifo thresholds */
	sc->wl_cfblk.fifo_32 = 1;
	sc->wl_cfblk.throttle_enb = FALSE;
	sc->wl_cfblk.preamb_len = 0;	/* 1 (2^(n+1) - 1) byte preamble */
	sc->wl_cfblk.exp_prio = 5;	/* don't conform to 802.3 backoff algoritm */
	sc->wl_cfblk.bof_met = 1;	/* don't conform to 802.3 backoff algoritm */
	sc->wl_cfblk.ifrm_spc = 2;	/* 32 bit times interframe spacing */
	sc->wl_cfblk.slottim_low = (0x20 >> 5);	/* 64 bit times slot time */
	sc->wl_cfblk.slottim_hi =  (0x20 >> 8);
#else
	sc->wl_cfblk.fifo_limit = 6;	/* = 48 byte rx/tx fifo thresholds */
	sc->wl_cfblk.fifo_32 = 0;
	sc->wl_cfblk.throttle_enb = TRUE;
	sc->wl_cfblk.preamb_len = 2;	/* 7 (2^(n+1) - 1) byte preamble */
	sc->wl_cfblk.exp_prio = 0;	/* conform to 802.3 backoff algoritm */
	sc->wl_cfblk.bof_met = 0;	/* conform to 802.3 backoff algoritm */
	sc->wl_cfblk.ifrm_spc = 6;	/* 96 bit times interframe spacing */
#ifdef 0
	sc->wl_cfblk.slottim_low = (0x200 >> 5);	/* 512 bit times slot time */
	sc->wl_cfblk.slottim_hi  = (0x200 >> 8);
#else
	sc->wl_cfblk.slottim_low = 0x10 & 0x7;	/* 512 bit times slot time */
	sc->wl_cfblk.slottim_hi = 0x10 >> 3;
#endif
#endif

	/* constant stuff
	 */
	sc->wl_cfblk.contin = TRUE;	/* enable continous mode */
	sc->wl_cfblk.addr_len = WAVELAN_ADDR_SIZE;
	sc->wl_cfblk.lin_prio = 0;	/* conform to 802.3 backoff algoritm */
	sc->wl_cfblk.max_retr = 15;	
	sc->wl_cfblk.crs_1 = TRUE;	/* Transmit without carrier sense */
	sc->wl_cfblk.nocrc_ins = FALSE;	/* 82593 generates CRC */	
	sc->wl_cfblk.crc_1632 = FALSE;	/* 32-bit Autodin-II CRC */
	sc->wl_cfblk.crs_cdt = FALSE;	/* CD not to be interpreted as CS */
	sc->wl_cfblk.cs_filter = 0;	/* CS sc recognized immediately */
	sc->wl_cfblk.crs_src = FALSE;	/* External carrier sense */
	sc->wl_cfblk.cd_filter = 0;	/* CD is recognized immediately */
	sc->wl_cfblk.min_fr_len = 	/* Minimum frame length 64 bytes */
		(sizeof(struct ether_header) + ETHERMIN + sizeof(long)) >> 2;
	sc->wl_cfblk.lng_typ = FALSE;	/* Length field > 1500 = type field */
	sc->wl_cfblk.lng_fld = TRUE;	/* Dscable 802.3 length field check */
	sc->wl_cfblk.rxcrc_xf = TRUE;	/* Don't transfer CRC to memory */
	sc->wl_cfblk.artx = TRUE;	/* Disable automatic retransmission */
	sc->wl_cfblk.sarec = TRUE;	/* Disable source addr trig of CD */
	sc->wl_cfblk.tx_jabber = TRUE;	/* Disable jabber jam sequence */
	sc->wl_cfblk.hash_1 = FALSE;	/* Use bits 0-5 in mc address hash */
	sc->wl_cfblk.lbpkpol = TRUE;	/* Loopback pin active high */
	sc->wl_cfblk.fdx = FALSE;	/* Disable full duplex operation */
	sc->wl_cfblk.dummy_6 = 0x3f;	/* all ones */
	sc->wl_cfblk.mult_ia = FALSE;	/* No multiple individual addresses */
	sc->wl_cfblk.dis_bof = FALSE;	/* Disable the backoff algorithm ?! */
	sc->wl_cfblk.dummy_1 = TRUE;	/* set to 1 */
	sc->wl_cfblk.tx_ifs_retrig = 3;	/* Hmm... Disabled */
	sc->wl_cfblk.rcv_mon = 0;		/* Monitor mode disabled */
	sc->wl_cfblk.frag_acpt = FALSE;	/* Do not accept fragments */
	sc->wl_cfblk.tstrttrs = FALSE;	/* No start transmission threshold */
	sc->wl_cfblk.fretx = TRUE;		/* FIFO automatic retransmission */
	sc->wl_cfblk.syncrqs = TRUE;	/* Synchronous DRQ deassertion... */
	sc->wl_cfblk.sttlen = TRUE;	/* 6 byte status registers */
	sc->wl_cfblk.rx_eop = TRUE;	/* Signal EOP on packet reception */
	sc->wl_cfblk.tx_eop = TRUE;	/* Signal EOP on packet transmission */
	sc->wl_cfblk.rbuf_size = RX_SIZE>>11;	/* Set receive buffer size */
	sc->wl_cfblk.rcvstop = TRUE;	/* Enable Receive Stop Register */

	/* iffy stuff
	 */
	if (WLPIF(unit).if_flags & (IFF_PROMISC|IFF_LINK1))
		sc->wl_cfblk.prmisc = TRUE;
	else
		sc->wl_cfblk.prmisc = FALSE;
#if MULTICAST
	if ((WLPIF(unit).if_flags & IFF_ALLMULTI) && 
	    (WLPIF(unit).if_flags & IFF_PROMISC) == 0)
		sc->wl_cfblk.mc_all = TRUE;
	else
		sc->wl_cfblk.mc_all = FALSE;
#endif
	
	outb(PIORL(base), TX_BASE & 0xff);
	outb(PIORH(base), ((TX_BASE >> 8) & PIORH_MASK) | PIORH_SEL_TX);
	outb(PIOP(base), sizeof(struct i82593) & 0xff); /* lsb */
	outb(PIOP(base), sizeof(struct i82593) >> 8);	/* msb */
	loutb(PIOP(base), &sc->wl_cfblk, sizeof(struct i82593));
	/* reset transmit DMA pointer */
	outb(HACR(base), HACR_PWR_STAT | HACR_TX_DMA_RESET);
	DELAY(1000);
	outb(HACR(base), HACR_PWR_STAT);
	DELAY(1000);
	if (!wl_cmd(unit, "wl_config(): configure",
		    OP0_CONFIGURE, SR0_CONFIGURE_DONE))
		return (FALSE);
	
#if 0	
#ifdef ORIGINAL_CONFIG
	/*
	 * below is the default board configuration from p2-28 from 586 book
	 */
	configure.fifolim_bytecnt 	= 0x080c;
	configure.addrlen_mode  	= 0x2600;
	configure.linprio_interframe	= 0x7820;	/* IFS=120, ACS=2 */
	configure.slot_time      	= 0xf00c;	/* slottime=12    */
	configure.hardware	     	= 0x0008;	/* tx even w/o CD */
	configure.min_frame_len   	= 0x0040;
#else
	/* This is the configuration block suggested by Marc Meertens
	 * <mmeerten@obelix.utrecht.NCR.COM> in an e-mail message to John
	 * Ioannidis on 10 Nov 92.
	 */
	configure.fifolim_bytecnt 	= 0x040c;
 	configure.addrlen_mode  	= 0x0600;
	configure.linprio_interframe	= 0x2060;
	configure.slot_time      	= 0xf000;
	configure.hardware	     	= 0x0008;	/* tx even w/o CD */
	configure.min_frame_len   	= 0x0040;
#endif	ORIGINAL_CONFIG
#endif 0
	
#if	MULTICAST
	outb(PIORL(base), (TX_BASE + 2) & 0xff);
	outb(PIORH(base), (((TX_BASE + 2) >> 8) & PIORH_MASK) | PIORH_SEL_TX);
	ETHER_FIRST_MULTI(step, &(WLPSOFTC(unit)->wl_ac), enm);
	while (enm != NULL) {
		unsigned int lo, hi;

		lo = (enm->enm_addrlo[3] << 16) + (enm->enm_addrlo[4] << 8)
			+ enm->enm_addrlo[5];
		hi = (enm->enm_addrhi[3] << 16) + (enm->enm_addrhi[4] << 8)
			+ enm->enm_addrhi[5];
		while (lo <= hi) {
			outb(PIOP(base), enm->enm_addrlo[0]);
			outb(PIOP(base), enm->enm_addrlo[1]);
			outb(PIOP(base), enm->enm_addrlo[2]);
			outb(PIOP(base), lo >> 16);
			outb(PIOP(base), (lo >> 8) & 0xff);
			outb(PIOP(base), lo & 0xff);
			cnt++;
			lo++;
		}
		ETHER_NEXT_MULTI(step, enm);
	}
	/* write the size of the multicast address area */
	outb(PIORL(base), TX_BASE & 0xff);
	outb(PIORH(base), ((TX_BASE >> 8) & PIORH_MASK) | PIORH_SEL_TX);
	outb(PIOP(base), (cnt * WAVELAN_ADDR_SIZE) & 0xff);
	outb(PIOP(base), (cnt * WAVELAN_ADDR_SIZE) >> 8);
	/* reset transmit DMA pointer */
	outb(HACR(base), HACR_PWR_STAT | HACR_TX_DMA_RESET);
	DELAY(1000);
	outb(HACR(base), HACR_PWR_STAT);
	DELAY(1000);
	if (!wl_cmd(unit, "wl_config(): mc-setup", OP0_MC_SETUP, SR0_MC_SETUP_DONE)) {
		printf("wl%d: multicast setup failed\n", unit);
		return (FALSE);
	}
#endif	MULTICAST
	
	outb(PIORL(base), TX_BASE & 0xff);
	outb(PIORH(base), ((TX_BASE >> 8) & PIORH_MASK) | PIORH_SEL_TX);
	outb(PIOP(base), WAVELAN_ADDR_SIZE);	/* byte count lsb */
	outb(PIOP(base), 0);			/* byte count msb */
	loutb(PIOP(base), sc->wl_enaddr, WAVELAN_ADDR_SIZE);
	/* reset transmit DMA pointer */
	outb(HACR(base), HACR_PWR_STAT | HACR_TX_DMA_RESET);
	DELAY(1000);
	outb(HACR(base), HACR_PWR_STAT);
	DELAY(1000);
	if(!wl_cmd(unit, "wl_config(): ia-setup",
		   OP0_IA_SETUP, SR0_IA_SETUP_DONE))
		return (FALSE);
	return (TRUE);
}

void
wl_dump(int unit) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;
	int i, c;

	/* disable receiver so we can use channel 1 */
	outb(LCCR(base), OP0_RCV_DISABLE);

	outb(HACR(base), HACR_PWR_STAT | HACR_RX_DMA_RESET);
	DELAY(1000);
	outb(HACR(base), HACR_PWR_STAT);
	DELAY(1000);

	/* dump into receive buffer */
	wl_cmd(unit, "wl_dump(): dump", CR0_CHNL|OP0_DUMP, SR0_DUMP_DONE);

	/* set read pointer to start of receive buffer */
	outb(PIORL(base), 0);
	outb(PIORH(base), 0);

	printf("wl%d dump:", unit);
	for (i = 0; i < 72; i++){
		if ((i % 16) == 0)
			printf("\n");
		c = inb(PIOP(base));
		printf("%02x ", c);
	}
	printf("\n");

	/* enable the receiver again */
	wl_rustrt(unit);
}

/*
 * wl_xmt:
 *
 *	This routine fills in the appropriate registers and memory
 *	locations on the WaveLAN board and starts the board off on
 *	the transmit.
 *
 * input	: board number of interest, and a pointer to the mbuf
 * output	: board memory and registers are set for xfer and attention
 */
void wl_xmt(int unit, struct mbuf *m) {
	wl_softc_t *sc = WLPSOFTC(unit);
	u_short xmtdata_p, xmtdata_base = TX_BASE;
	u_short	clen = 0;		/* total pkt data len */
	int count;			/* data in current mbuf */
	int base = sc->wl_base;
	struct ether_header *eh_p = mtod(m, struct ether_header *);
	struct mbuf *tm_p = m;
	u_char *mb_p = mtod(m, u_char *) + sizeof(struct ether_header);

	ccdprintf(("wl%d: wl_xmt, type 0x%04x\n", unit, eh_p->ether_type));

	xmtdata_p = xmtdata_base + 2; /* skip length field */
	outb(PIORL(base), xmtdata_p & 0xff);
	outb(PIORH(base), ((xmtdata_p >> 8) & PIORH_MASK) | PIORH_SEL_TX);
	loutb(PIOP(base), eh_p->ether_dhost, WAVELAN_ADDR_SIZE);
	outb(PIOP(base), eh_p->ether_type & 0xff);
	outb(PIOP(base), eh_p->ether_type >> 8);

	count = m->m_len - sizeof(struct ether_header);
	clen = 0;
	for (;;) {
		if (count) {
			loutb(PIOP(base), mb_p, count);
			clen += count;
		}
		if ((tm_p = tm_p->m_next) == (struct mbuf *)0)
			break;
		count = tm_p->m_len;
		mb_p = mtod(tm_p, u_char *);
	}

	ccdprintf(("CLEN = %d\n", clen));
	if (clen < ETHERMIN) {
		for (; clen < ETHERMIN; ++clen)
			outb(PIOP(base), 0);
	}
	outb(PIOP(base), OP0_NOP); /* Indicate end of transmit chain */
	/* write length of data buffer */
	clen += WAVELAN_ADDR_SIZE + sizeof(eh_p->ether_type);
	outb(PIORL(base), xmtdata_base & 0xff);
	outb(PIORH(base), ((xmtdata_base >> 8) & PIORH_MASK) | PIORH_SEL_TX);
	outb(PIOP(base), clen & 0xff); /* lsb */
	outb(PIOP(base), clen >> 8); /* msb */
#ifdef	IF_CNTRS
	clen += 4		/* crc */;
	wl_ifcntrs.pkt_eout[log_2(clen)]++;
	if (clen < 128)
		wl_ifcntrs.pkt_lout[clen>>3]++;
#endif	IF_CNTRS

	/* reset transmit DMA pointer */
	outb(HACR(base), HACR_PWR_STAT | HACR_TX_DMA_RESET);
	DELAY(1000);
	outb(HACR(base), HACR_PWR_STAT);
	DELAY(1000);
	/* transmit command */
	wl_cmd(unit, "wl_xmt(): transmit", OP0_TRANSMIT, SR0_NO_RESULT);
	m_freem(m);
	return;
}

/*
 * wl_intr:
 *
 *	This function is the interrupt handler for the WaveLAN
 *	board.  This routine will be called whenever either a packet
 *	is received, or a packet has successfully been transfered and
 *	the unit is ready to transmit another packet.
 *
 * input	: board number that interrupted
 * output	: either a packet is received, or a packet is transfered
 */
wl_intr(struct wl_softc *sc) {
	int unit = sc->wl_dev.dv_unit;
	int base = sc->wl_base;
	int expected = 0;
	int status0;
     
	ccdprintf(("wl%d: wl_intr() called\n", unit));

	if (!(sc->wl_flags & WL_SEATED)) { 
		printf("wl%d intr(): board not seated\n", unit);
		return (0);
	}
	for (expected = 0; ; expected = 1) {
		outb(LCCR(base), CR0_STATUS_0 | OP0_NOP);
		status0 = inb(LCSR(base));
		/* return if no interrupt from 82593 */
		if(!(status0 & SR0_INTERRUPT))
			return (expected); 
		sc->wl_status = status0;
		if (status0 & SR0_RECEPTION) {
			if ((status0 & SR0_EVENT_MASK) == SR0_STOP_REG_HIT) {
#ifdef DEBUG
				printf("wl_intr: wl%d: receive buffer overflow\n", unit);
#endif
				sc->wl_cntrs.rcv.ovw++;
				WLPIF(unit).if_ierrors++;
				sc->wl_flags |= WL_OVERRUNNING;
#ifdef DEBUG
				printf("Overrunning... restarting receive unit\n");
				printf("Multiple frames may be lost -- up to 8KB\n");
				/* Restart receive unit if overflow occurs */

				printf("CRC errors: %d\n", sc->wl_cntrs.rcv.crc);
				printf("SFD errors: %d\n", sc->wl_cntrs.rcv.frame);
				printf("Overrun errors: %d\n", sc->wl_cntrs.rcv.ovrnerrs);
				printf("Total errors: %d\n", WLPIF(unit).if_ierrors);
#endif
				wl_init(unit);
			}
			wl_rcv(unit);
			sc->wl_flags &= ~WL_OVERRUNNING;
#ifdef	TIMER
			watch_dead = 0;
#endif	TIMER
			if (status0 & SR0_EXECUTION) {
				printf("wl%d: interrupt is both rx and tx, status0 = %x\n",
				       unit, status0);
			}
			/* acknowledge the interrupt */
			outb(LCCR(base), CR0_INT_ACK | OP0_NOP);
			continue;
		}
		else
			if (!(status0 & SR0_EXECUTION)) {
				printf("wl%d: interrupt neither rx or tx, status0 = %x\n",
				       unit,status0);
				/* acknowledge the interrupt */
				outb(LCCR(base), CR0_INT_ACK | OP0_NOP);
				break;
			}
		if ((sc->wl_flags & WL_CMD_WAIT)) {
			/* We are waiting for a command to complete */
			sc->wl_flags &= ~WL_CMD_WAIT; /* signal command completed */
			/* acknowledge the interrupt */
			outb(LCCR(base), CR0_INT_ACK | OP0_NOP);
			/* If we had to defer call to wl_start previously,
			   make up for it by calling wl_start now */
			if ((sc->wl_flags & WL_DEFERRED)) {
				wl_start(&(WLPIF(unit)));
				sc->wl_flags &= ~WL_DEFERRED;
			}
			continue;
		}
		if((status0 & SR0_EVENT_MASK) == SR0_TRANSMIT_DONE ||
		   (status0 & SR0_EVENT_MASK) == SR0_RETRANSMIT_DONE) {
			int tx_status;

			tx_status = inb(LCSR(base));
			tx_status |= inb(LCSR(base)) << 8;
			if (!(tx_status & TX_OK)) {
				if (tx_status & TX_FRTL) {
					if (xmt_watch)
						printf("wl%d: frame too long\n", unit);
					WLPIF(unit).if_oerrors++;
				}
				if (tx_status & TX_UND_RUN) {
					if (xmt_watch)
						printf("wl%d: DMA underrun\n", unit);
					sc->wl_cntrs.xmt.dma++;
					WLPIF(unit).if_oerrors++;
				}
				if (tx_status & TX_LOST_CTS) {
					if (xmt_watch)
						printf("wl%d: no CTS\n", unit);
					sc->wl_cntrs.xmt.nocts++;
					WLPIF(unit).if_oerrors++;
				}
				if (tx_status & TX_LOST_CRS) {
					/* if (xmt_watch)
					   printf("wl%d: no carrier\n", unit); */
					sc->wl_cntrs.xmt.nodcd++;
				}
				/* Ignore late collisions. Act only when maximum
				   retransmit attempts exceeded */
				if (tx_status & TX_COLL) {
					if (tx_status & TX_MAX_COL) {
						if (xmt_watch)
							printf("wl%d: channel congestion\n", unit);
						if (!(tx_status & TX_NCOL_MASK)) {
							WLPIF(unit).if_collisions += 0x10;
							sc->wl_cntrs.xmt.ncoll += 0x10;
						}
					}
					sc->wl_cntrs.xmt.coll++;
					WLPIF(unit).if_oerrors++;
				}
			}
			if (tx_status & TX_DEFER) {
				if (xmt_watch)
					printf("wl%d: channel jammed\n",unit);
				sc->wl_cntrs.xmt.defer++;
			}
			if (tx_status & TX_HRT_BEAT) {
				if (xmt_watch)
					printf("wl%d: heart beat\n", unit);
				sc->wl_cntrs.xmt.heart++;
			}
			WLPIF(unit).if_collisions += (tx_status & TX_NCOL_MASK);
			sc->wl_cntrs.xmt.ncoll += (tx_status & TX_NCOL_MASK);
			sc->wl_cntrs.xmt.xmti++;
			sc->wl_flags &= ~WL_TBUSY;
			/* acknowledge the interrupt */
			outb(LCCR(base), CR0_INT_ACK | OP0_NOP);
			/* Defer call to wl_start if we are waiting to be
			   able to issue a command */
			if ((sc->wl_flags & WL_CMD_REQUEST)) {
				sc->wl_flags |= WL_DEFERRED;
				break;
			}
			wl_start(&(WLPIF(unit)));
		}
		else {
			printf("wl%d: unknown interrupt, status0 = %02x\n",
			       unit, status0);
			/* acknowledge the interrupt */
			outb(LCCR(base), CR0_INT_ACK | OP0_NOP);
		}
#ifdef	TIMER
		sc->wl_timer = 5;
#endif	TIMER
	}
	return (expected);
}

/* Send a command to the 82593 chip.  Must be called with interrupts enabled */

wl_cmd(int unit, char *str, int cmd, int result) {
	wl_softc_t *sc = WLPSOFTC(unit);
	int base = sc->wl_base;
	int status, spin;

	sc->wl_flags |= WL_CMD_REQUEST;	/* signal that we want to issue a command */
	/* spin until the chip finished executing any current command */
	do {
		int s = SPLNET();

		outb(LCCR(base), OP0_NOP | CR0_STATUS_3);
		status = inb(LCSR(base));
		splx(s);
	} while ((status & SR3_EXEC_STATE_MASK) != SR3_EXEC_IDLE);

	sc->wl_flags |= WL_CMD_WAIT;	/* signal that we are waiting for command completion */
	sc->wl_flags &= ~WL_CMD_REQUEST;
	outb(LCCR(base), cmd);
	if (result == SR0_NO_RESULT) {		/* Return immediately */
		sc->wl_flags &= ~WL_CMD_WAIT;
		/* if a call to wl_start was deferred, make up for it now */
		if ((sc->wl_flags & WL_DEFERRED)) {
			wl_start(&(WLPIF(unit))); /* idempotent */
			sc->wl_flags &= ~WL_DEFERRED;
		}
		return (TRUE);
	}

	/* interrupts better be enabled while we busy wait */
	/* but in_ifinit() turns them off! */
	/* could enable just the WaveLAN's IRQ... */
	for (spin = 0; spin < 10000000 && (sc->wl_flags & WL_CMD_WAIT); spin++)
	        ;

	if ((sc->wl_flags & WL_CMD_WAIT)) {
		outb(LCCR(base), OP0_NOP);
		status = inb(LCSR(base));
		if (status & 0x80){
			wl_intr(sc);
		} else {
			sc->wl_flags &= ~WL_CMD_WAIT;
			printf("wl_cmd timeout, status0 %02x\n", status);
			return (FALSE);
		}
	}

	/* check the return code, provided by the interrupt handler */
	if ((sc->wl_status & SR0_EVENT_MASK) != result) {
		printf("wl%d: %s failed, status0 = %x\n", unit, str, sc->wl_status);
		return (FALSE);
	}
	return (TRUE);
}

/* Calculates the SNR ratio.  Ignores sigqual and the ethernet header for
   the time being */
static void
wl_getsnr(int unit, struct ether_header *eh_p,
	  u_char siglvl, u_char sillvl, u_char sigqual)
{
	wl_softc_t *sc = WLPSOFTC(unit);
	int s, snrindex, i;
	int found = 0, empty = -1;

	if ((s = (siglvl & 0x3f)) > 0) {
		s -= (sillvl & 0x3f) - 0x2d;
		if (s >= 0x38)
			snrindex = 4;
		else if (s >= 0x2a)
			snrindex = 3;
		else if (s >= 0x1c)
			snrindex = 2;
		else if (s >= 0x0e)
			snrindex = 1;
		else if (s >= 0)
			snrindex = 0;
		else {
			ccdprintf(("wl%d: bogus snr level\n",unit));
			snrindex = 0;
		}
		sc->wl_cntrs.rcv.snr[snrindex]++;

		sc->wl_cntrs.mmc.siglvl = siglvl;
		sc->wl_cntrs.mmc.sillvl = sillvl;
		sc->wl_cntrs.mmc.sigqual = sigqual;

		for (i = 0; i < WL_NBEACONS; i++) {
			if (bcmp(eh_p->ether_shost,
				 sc->wl_cntrs.beacons[i].eth_addr,
				 ETHER_ADDR_LEN) == 0) {
				found = 1;
#if 0
				printf("found [%x:%x:%x:%x:%x:%x] at %d\n", 
				       eh_p->ether_shost[0], 
				       eh_p->ether_shost[1], 
				       eh_p->ether_shost[2], 
				       eh_p->ether_shost[3], 
				       eh_p->ether_shost[4], 
				       eh_p->ether_shost[5],
				       i);
#endif
				break;
			}
#if 0
			else if (empty == -1 && sc->wl_cntrs.beacons[i].siglvl == 0)
#endif
			else if (empty == -1 
			         && EZERO(sc->wl_cntrs.beacons[i].eth_addr))
				empty = i;
		}
		
		if (found) {
			sc->wl_cntrs.beacons[i].sigqual = sc->wl_cntrs.mmc.sigqual;
			sc->wl_cntrs.beacons[i].siglvl = sc->wl_cntrs.mmc.siglvl;
			sc->wl_cntrs.beacons[i].sillvl = sc->wl_cntrs.mmc.sillvl;
		} else if (empty != -1) {
			int j;
			i = empty;
			for (j = 0; j < ETHER_ADDR_LEN; j++) {
				sc->wl_cntrs.beacons[i].eth_addr[j] =
					eh_p->ether_shost[j];
			}
			sc->wl_cntrs.beacons[i].sigqual = sc->wl_cntrs.mmc.sigqual;
			sc->wl_cntrs.beacons[i].siglvl = sc->wl_cntrs.mmc.siglvl;
			sc->wl_cntrs.beacons[i].sillvl = sc->wl_cntrs.mmc.sillvl;
		}
	}
}

#ifdef TIMING
/* Compute the difference between times 'now' and 'then' in microseconds */
long
time_diff(struct timeval *now, struct timeval *then) {
        long diff;

	diff = (now->tv_sec - then->tv_sec) * 1000000 + 
		now->tv_usec - then->tv_usec;

	return (diff);
}
#endif TIMING

/*
 * wl_ioctl:
 *
 *	This routine processes an ioctl request from the "if" layer
 *	above.
 *
 * input	: pointer the appropriate "if" struct, command, and data
 * output	: based on command appropriate action is taken on the
 *	 	  WaveLAN board(s) or related structures
 * return	: error is returned containing exit conditions
 */
int
wl_ioctl(struct ifnet *ifp, u_long cmd, caddr_t data) {
	struct ifaddr *ifa = (struct ifaddr *)data;
	struct ifreq *ifr = (struct ifreq *)data;
	struct ifbeacon *ifb = (struct ifbeacon *)data;
	struct ifcntr *ifc = (struct ifcntr *)data;
	struct ifnwid *ifn = (struct ifnwid *)data;
	struct ifgather *ifg = (struct ifgather *)data;
	struct ifhwaddr *ifh = (struct ifhwaddr *)data;
	struct ifwflags *ifw = (struct ifwflags *)data;
	struct ifencr *ife = (struct ifencr *)data;
	int unit = ifp->if_unit;
	struct wl_softc *sc = WLPSOFTC(unit);
	short base, mode = 0;
	int error = 0;

	ccdprintf(("wl%d: entered wl_ioctl(), cpl %x\n", unit, cpl));

	/* The card might have been ejected. */
	if (sc == 0)
		return (EINVAL);

	base = sc->wl_base;
	switch (cmd) {
	case SIOCSIFADDR:
		/* Set own IP address and enable interface */
		ifp->if_flags |= IFF_UP;
		wl_init(unit);
		switch (ifa->ifa_addr->sa_family) {
#ifdef INET
		    case AF_INET: {
			arp_ifinit((struct arpcom *)ifp, ifa);
			break;
		    }
#endif
#ifdef NS
		    case AF_NS: {
			struct ns_addr *ina = &(IA_SNS(ifa)->sns_addr);

			if (ns_nullhost(*ina))
				ina->x_host = *(union ns_host *)(sc->wl_enaddr);
			else
#ifdef notyet
				/*
				 * We could probably copy to sc->wl_enaddr
				 * and then call wl_hwrst():
				 *
				 * bcopy(ina->x_host.c_host, sc->wl_enaddr,
				 *    sizeof(sc->we_addr));
				 * wl_hwrst(unit);
				 */
				wl_setaddr(ina->x_host.c_host, unit);
#else
				error = EADDRNOTAVAIL;	/* XXX */
#endif
			break;
		    }
#endif
		}
		break;

	case SIOCSIFFLAGS:
		if (ifp->if_flags & (IFF_PROMISC|IFF_LINK0))
			mode |= MOD_PROM;
		else if (ifp->if_flags & IFF_ALLMULTI)
			mode |= MOD_ENAL;
		/*
		 * force a complete reset if the receive multicast/
		 * promiscuous mode changes so that these take 
		 * effect immediately.
		 *
		 */
		if (sc->wl_mode != mode) {
			sc->wl_mode = mode;
			sc->wl_flags &= ~WL_RUNNING;
		}
		
		if (!(ifp->if_flags & IFF_UP) && (sc->wl_flags & WL_RUNNING)) {
			printf("wl%d ioctl(): board is not running\n", unit);
			sc->wl_flags &= ~WL_RUNNING;
#ifdef	TIMER
			sc->wl_timer = -1;
#endif	TIMER
			/* turn off interrupts? */
		} else if ((ifp->if_flags & IFF_UP) && !(sc->wl_flags & WL_RUNNING)) {
#ifdef TIMING
			long diff;

			struct timeval start, end;
			microtime(&start);
#endif			
			wl_init(unit);
#ifdef TIMING
			microtime(&end);
			diff=time_diff(&end, &start);
			printf("Elapsed time=%d usec\n", diff);
#endif			
			
		}
		if (ifp->if_flags & IFF_LINK2)
			wl_dump(unit);
		break;
#if MULTICAST
	case SIOCADDMULTI:
	case SIOCDELMULTI:
		error = (cmd == SIOCADDMULTI) ?
			ether_addmulti(ifr, &sc->wl_ac) :
			ether_delmulti(ifr, &sc->wl_ac);
		if (error == ENETRESET) {
			if ((sc->wl_flags & WL_RUNNING)) {
				sc->wl_flags &= ~WL_RUNNING;
				wl_init(unit);
			}
			error = 0;
		}
		break;
#endif	MULTICAST

#ifdef  BEACONS
	case SIOCSIFBEACON: {
		int found = 0, empty = -1, i;
#if 0
		printf("wl_ioctl: wl%d beacon ioctl\n", unit);
#endif
		for (i = 0; i < WL_NBEACONS; i++) {
			if (bcmp(&ifb->beacon.eth_addr,
				 &sc->wl_cntrs.beacons[i].eth_addr,
				 sizeof ifb->beacon.eth_addr) == 0) {
			        found = 1;
#if 0
				printf("wl_ioctl: found entry at %d\n", i);
#endif
				break;
			}
			else if (empty == -1 
				 && EZERO(sc->wl_cntrs.beacons[i].eth_addr))
				empty = i;
		}
		
		switch (ifb->cmd) {
		case ADD_BEACON:
			if (!found) {
				if (empty == -1) {
					printf("wl_ioctl:beacon table full\n");
					error = ENOBUFS;
				} else {
					bcopy(&ifb->beacon,
					      &sc->wl_cntrs.beacons[empty],
					      sizeof ifb->beacon);
				}
			}
			break;
		case DEL_BEACON:
			if (!found) 
				error = EADDRNOTAVAIL;
			else {
				bzero(&sc->wl_cntrs.beacons[i],
				      sizeof sc->wl_cntrs.beacons[i]);
			}
			break;
		default: 
			error = EINVAL;
		}
		break;
	}
	case SIOCGIFBEACON: 
		if (ifb->cmd < 0 || ifb->cmd >= WL_NBEACONS) {
			error = EINVAL;
		} else {
			ifb->beacon = sc->wl_cntrs.beacons[ifb->cmd];
		}
		break;
#endif
	case SIOCSIFNWID:
		if (ifn->cmd & SET_NWID) {
			sc->wl_nwid[0] = ifn->nwid[0];
			sc->wl_nwid[1] = ifn->nwid[1];
			sc->wl_cntrs.nwid[0] = sc->wl_cntrs.mmc.cur_nwid[0] = sc->wl_nwid[0];
			sc->wl_cntrs.nwid[1] = sc->wl_cntrs.mmc.cur_nwid[1] = sc->wl_nwid[1];
		}
		if (ifn->cmd & SET_MODE)
			if (ifn->nwid_mode)
				sc->wl_flags |= WL_ALLNWID_MODE;
			else
				sc->wl_flags &= ~WL_ALLNWID_MODE;
		if ((sc->wl_flags & WL_ATTACHED)) {
			sc->wl_flags &= ~WL_MMI_INITED;
			wl_initmmi(unit);
		}
		break;
	case SIOCGIFNWID:
		ifn->nwid[0] = sc->wl_nwid[0];
		ifn->nwid[1] = sc->wl_nwid[1];
		ifn->nwid_mode = ((sc->wl_flags & WL_ALLNWID_MODE) == WL_ALLNWID_MODE);
		break;
	case SIOCGIFCNTR:
		update_mmc_status(unit);
		ifc->counters = sc->wl_cntrs;
		break;
        case SIOCSIFGATHER:
		if (ifg->gather)
			sc->wl_flags |= WL_GATHER_SNR;
		else
			sc->wl_flags &= ~WL_GATHER_SNR;
		break;
        case SIOCGIFGATHER:
                ifg->gather = ((sc->wl_flags & WL_GATHER_SNR) == WL_GATHER_SNR);
		break;
	case SIOCGIFHWADDR:
		bcopy(sc->wl_enaddr, ifh->eth_addr, sizeof(sc->wl_enaddr));
		break;
	case SIOCGIFWFLAGS:
		ifw->flags = sc->wl_flags;
		break;
	case SIOCSIFENCR:
		{
			int i;
			if (!wl_canencrypt(sc))
				return ENODEV;
			sc->wl_doencrypt = ife->ife_encrypt;
			for (i = 0; i < DES_KEY_SIZE; i++)
				sc->wl_key[i] = ife->ife_key[i];
			wl_encrypt(sc);
			break;
		}
	case SIOCGIFENCR:
		{
			int i;
			if (!wl_canencrypt(sc))
				return ENODEV;
			ife->ife_encrypt = sc->wl_doencrypt;
			for (i = 0; i < DES_KEY_SIZE; i++) {
				ife->ife_key[i] = sc->wl_key[i];
				ife->ife_key[i] = 0;	/* for safety... */
			}
			break;
		}
	default:
		error = EINVAL;
	}
	return (error);
}
